<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: MDrawControl Struct Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="classes.html"><span>Data&nbsp;Structure&nbsp;Index</span></a></li>
      <li><a href="functions.html"><span>Data&nbsp;Fields</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>MDrawControl Struct Reference<br/>
<small>
[<a class="el" href="group__m17nDraw.html">Drawing</a>]</small>
</h1><!-- doxytag: class="MDrawControl" -->
<p>Type of a text drawing control.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Fields</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#af301cfe17b9e439d316e110a0bf3c92f">as_image</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a5aa326c8b84bf768b68596f6abafab42">align_head</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#aa8078b02cc0922ee8c67b9633b68ec14">two_dimensional</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a1d5acd8d1a0da026c17c0c514ad6a303">orientation_reversed</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#aa1e5f8852e113906ae304de0392585cb">enable_bidi</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a5552f972cdf5378dd22001e30ea76c6c">ignore_formatting_char</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#ae64a993e19d6a445da577908b00f3215">fixed_width</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#acb409990f67127a3b770085d45f6ce2d">anti_alias</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a8ab506d53849a2527b91355d784c4fe9">disable_overlapping_adjustment</a>: 1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a5dcb86bffa8bdbd27d9c629e972c8e4d">min_line_ascent</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#af101c1b8c432dfdeeb9aedcc2acd788d">min_line_descent</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a580b5482104099d6d0b087e575e3bf49">max_line_ascent</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a2801c3613af8ee5ffede27cdbcc1c91e">max_line_descent</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a7fc02b6a32786c4cb255c706f89dd1a4">max_line_width</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a80fd394fb5a68f773c06badcff75a67f">tab_width</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a12ce6429f5889dc5e9dd7b96c3be6ed4">format</a> )(int line, int y, int *indent, int *width)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a01f9bbffae254744fefe98794f357439">line_break</a> )(<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos, int from, int to, int line, int y)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a06b6e4aa0a938077c6a3885f26e00fa1">with_cursor</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a86f43b5b69cac1ae87df02d129bb41cb">cursor_pos</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#abecdf1eed786dd72a99a58a77508c605">cursor_width</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#acc07249ccdbadac27613ef85e3eaf619">cursor_bidi</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#ab2291cc39af2f862b4e5ebd1dbba4162">partial_update</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a5e496fa6dcad730d7d04048b87c0d01e">disable_caching</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nDraw.html#ga9818c0695d9162a9637fa4e98a1d477d">MDrawRegion</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html#a3485775bf4708899bbad2626e6c594ce">clip_region</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Type of a text drawing control. </p>
<p>The type <a class="el" href="structMDrawControl.html" title="Type of a text drawing control.">MDrawControl</a> is the structure that controls how to draw an M-text. </p>
<hr/><h2>Field Documentation</h2>
<a class="anchor" id="af301cfe17b9e439d316e110a0bf3c92f"></a><!-- doxytag: member="MDrawControl::as_image" ref="af301cfe17b9e439d316e110a0bf3c92f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#af301cfe17b9e439d316e110a0bf3c92f">MDrawControl::as_image</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, draw an M-text as image, i.e. with background filled with background colors of faces put on the M-text. Otherwise, the background is not changed. </p>

</div>
</div>
<a class="anchor" id="a5aa326c8b84bf768b68596f6abafab42"></a><!-- doxytag: member="MDrawControl::align_head" ref="a5aa326c8b84bf768b68596f6abafab42" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#a5aa326c8b84bf768b68596f6abafab42">MDrawControl::align_head</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero and the first glyph of each line has negative lbearing, shift glyphs horizontally to right so that no pixel is drawn to the left of the specified position. </p>

</div>
</div>
<a class="anchor" id="aa8078b02cc0922ee8c67b9633b68ec14"></a><!-- doxytag: member="MDrawControl::two_dimensional" ref="aa8078b02cc0922ee8c67b9633b68ec14" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#aa8078b02cc0922ee8c67b9633b68ec14">MDrawControl::two_dimensional</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, draw an M-text two-dimensionally, i.e., newlines in M-text breaks lines and the following characters are drawn in the next line. If &lt;format&gt; is non-NULL, and the function returns nonzero line width, a line longer than that width is also broken. </p>

</div>
</div>
<a class="anchor" id="a1d5acd8d1a0da026c17c0c514ad6a303"></a><!-- doxytag: member="MDrawControl::orientation_reversed" ref="a1d5acd8d1a0da026c17c0c514ad6a303" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#a1d5acd8d1a0da026c17c0c514ad6a303">MDrawControl::orientation_reversed</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, draw an M-text to the right of a specified position. </p>

</div>
</div>
<a class="anchor" id="aa1e5f8852e113906ae304de0392585cb"></a><!-- doxytag: member="MDrawControl::enable_bidi" ref="aa1e5f8852e113906ae304de0392585cb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#aa1e5f8852e113906ae304de0392585cb">MDrawControl::enable_bidi</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, reorder glyphs correctly for bidi text. </p>

</div>
</div>
<a class="anchor" id="a5552f972cdf5378dd22001e30ea76c6c"></a><!-- doxytag: member="MDrawControl::ignore_formatting_char" ref="a5552f972cdf5378dd22001e30ea76c6c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#a5552f972cdf5378dd22001e30ea76c6c">MDrawControl::ignore_formatting_char</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, don't draw characters whose general category (in Unicode) is Cf (Other, format). </p>

</div>
</div>
<a class="anchor" id="ae64a993e19d6a445da577908b00f3215"></a><!-- doxytag: member="MDrawControl::fixed_width" ref="ae64a993e19d6a445da577908b00f3215" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#ae64a993e19d6a445da577908b00f3215">MDrawControl::fixed_width</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, draw glyphs suitable for a terminal. Not yet implemented. </p>

</div>
</div>
<a class="anchor" id="acb409990f67127a3b770085d45f6ce2d"></a><!-- doxytag: member="MDrawControl::anti_alias" ref="acb409990f67127a3b770085d45f6ce2d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#acb409990f67127a3b770085d45f6ce2d">MDrawControl::anti_alias</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, draw glyphs with anti-aliasing if a backend font driver supports it. </p>

</div>
</div>
<a class="anchor" id="a8ab506d53849a2527b91355d784c4fe9"></a><!-- doxytag: member="MDrawControl::disable_overlapping_adjustment" ref="a8ab506d53849a2527b91355d784c4fe9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned <a class="el" href="structMDrawControl.html#a8ab506d53849a2527b91355d784c4fe9">MDrawControl::disable_overlapping_adjustment</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, disable the adjustment of glyph positions to avoid horizontal overlapping at font boundary. </p>

</div>
</div>
<a class="anchor" id="a5dcb86bffa8bdbd27d9c629e972c8e4d"></a><!-- doxytag: member="MDrawControl::min_line_ascent" ref="a5dcb86bffa8bdbd27d9c629e972c8e4d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="structMDrawControl.html#a5dcb86bffa8bdbd27d9c629e972c8e4d">MDrawControl::min_line_ascent</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, the values are minimum line ascent pixels. </p>

</div>
</div>
<a class="anchor" id="af101c1b8c432dfdeeb9aedcc2acd788d"></a><!-- doxytag: member="MDrawControl::min_line_descent" ref="af101c1b8c432dfdeeb9aedcc2acd788d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="structMDrawControl.html#af101c1b8c432dfdeeb9aedcc2acd788d">MDrawControl::min_line_descent</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, the values are minimum line descent pixels. </p>

</div>
</div>
<a class="anchor" id="a580b5482104099d6d0b087e575e3bf49"></a><!-- doxytag: member="MDrawControl::max_line_ascent" ref="a580b5482104099d6d0b087e575e3bf49" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="structMDrawControl.html#a580b5482104099d6d0b087e575e3bf49">MDrawControl::max_line_ascent</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, the values are maximum line ascent pixels. </p>

</div>
</div>
<a class="anchor" id="a2801c3613af8ee5ffede27cdbcc1c91e"></a><!-- doxytag: member="MDrawControl::max_line_descent" ref="a2801c3613af8ee5ffede27cdbcc1c91e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="structMDrawControl.html#a2801c3613af8ee5ffede27cdbcc1c91e">MDrawControl::max_line_descent</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, the values are maximum line descent pixels. </p>

</div>
</div>
<a class="anchor" id="a7fc02b6a32786c4cb255c706f89dd1a4"></a><!-- doxytag: member="MDrawControl::max_line_width" ref="a7fc02b6a32786c4cb255c706f89dd1a4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="structMDrawControl.html#a7fc02b6a32786c4cb255c706f89dd1a4">MDrawControl::max_line_width</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, the value specifies how many pixels each line can occupy on the display. The value zero means that there is no limit. It is ignored if &lt;format&gt; is non-NULL. </p>

</div>
</div>
<a class="anchor" id="a80fd394fb5a68f773c06badcff75a67f"></a><!-- doxytag: member="MDrawControl::tab_width" ref="a80fd394fb5a68f773c06badcff75a67f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="structMDrawControl.html#a80fd394fb5a68f773c06badcff75a67f">MDrawControl::tab_width</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, the value specifies the distance between tab stops in columns (the width of one column is the width of a space in the default font of the frame). The value zero means 8. </p>

</div>
</div>
<a class="anchor" id="a12ce6429f5889dc5e9dd7b96c3be6ed4"></a><!-- doxytag: member="MDrawControl::format" ref="a12ce6429f5889dc5e9dd7b96c3be6ed4" args=")(int line, int y, int *indent, int *width)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void(* <a class="el" href="structMDrawControl.html#a12ce6429f5889dc5e9dd7b96c3be6ed4">MDrawControl::format</a>)(int line, int y, int *indent, int *width)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If non-NULL, the value is a function that calculates the indentation and width limit of each line based on the line number LINE and the coordinate Y. The function store the indentation and width limit at the place pointed by INDENT and WIDTH respectively.</p>
<p>The indentation specifies how many pixels the first glyph of each line is shifted to the right (if the member &lt;orientation_reversed&gt; is zero) or to the left (otherwise). If the value is negative, each line is shifted to the reverse direction.</p>
<p>The width limit specifies how many pixels each line can occupy on the display. The value 0 means that there is no limit.</p>
<p>LINE and Y are reset to 0 when a line is broken by a newline character, and incremented each time when a long line is broken because of the width limit.</p>
<p>This has an effect only when &lt;two_dimensional&gt; is nonzero. </p>

</div>
</div>
<a class="anchor" id="a01f9bbffae254744fefe98794f357439"></a><!-- doxytag: member="MDrawControl::line_break" ref="a01f9bbffae254744fefe98794f357439" args=")(MText *mt, int pos, int from, int to, int line, int y)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMDrawControl.html#a01f9bbffae254744fefe98794f357439">MDrawControl::line_break</a>)(<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos, int from, int to, int line, int y)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If non-NULL, the value is a function that calculates a line breaking position when a line is too long to fit within the width limit. POS is the position of the character next to the last one that fits within the limit. FROM is the position of the first character of the line, and TO is the position of the last character displayed on the line if there were not width limit. LINE and Y are the same as the arguments to &lt;format&gt;.</p>
<p>The function must return a character position to break the line.</p>
<p>The function should not modify MT.</p>
<p>The <a class="el" href="group__m17nDraw.html#ga457d91ccebabb26e1d7ab27f616cecb5" title="Calculate a line breaking position.">mdraw_default_line_break()</a> function is useful for such a script that uses SPACE as a word separator. </p>

</div>
</div>
<a class="anchor" id="a06b6e4aa0a938077c6a3885f26e00fa1"></a><!-- doxytag: member="MDrawControl::with_cursor" ref="a06b6e4aa0a938077c6a3885f26e00fa1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMDrawControl.html#a06b6e4aa0a938077c6a3885f26e00fa1">MDrawControl::with_cursor</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, show the cursor according to &lt;cursor_width&gt;. </p>

</div>
</div>
<a class="anchor" id="a86f43b5b69cac1ae87df02d129bb41cb"></a><!-- doxytag: member="MDrawControl::cursor_pos" ref="a86f43b5b69cac1ae87df02d129bb41cb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMDrawControl.html#a86f43b5b69cac1ae87df02d129bb41cb">MDrawControl::cursor_pos</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Specifies the character position to display a cursor. If it is greater than the maximum character position, the cursor is displayed next to the last character of an M-text. If the value is negative, even if &lt;cursor_width&gt; is nonzero, cursor is not displayed. </p>

</div>
</div>
<a class="anchor" id="abecdf1eed786dd72a99a58a77508c605"></a><!-- doxytag: member="MDrawControl::cursor_width" ref="abecdf1eed786dd72a99a58a77508c605" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMDrawControl.html#abecdf1eed786dd72a99a58a77508c605">MDrawControl::cursor_width</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, display a cursor at the character position &lt;cursor_pos&gt;. If the value is positive, it is the pixel width of the cursor. If the value is negative, the cursor width is the same as the underlining glyph(s). </p>

</div>
</div>
<a class="anchor" id="acc07249ccdbadac27613ef85e3eaf619"></a><!-- doxytag: member="MDrawControl::cursor_bidi" ref="acc07249ccdbadac27613ef85e3eaf619" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMDrawControl.html#acc07249ccdbadac27613ef85e3eaf619">MDrawControl::cursor_bidi</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero and &lt;cursor_width&gt; is also nonzero, display double bar cursors; at the character position &lt;cursor_pos&gt; and at the logically previous character. Both cursors have one pixel width with horizontal fringes at upper or lower positions. </p>

</div>
</div>
<a class="anchor" id="ab2291cc39af2f862b4e5ebd1dbba4162"></a><!-- doxytag: member="MDrawControl::partial_update" ref="ab2291cc39af2f862b4e5ebd1dbba4162" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMDrawControl.html#ab2291cc39af2f862b4e5ebd1dbba4162">MDrawControl::partial_update</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, on drawing partial text, pixels of surrounding texts that intrude into the drawing area are also drawn. For instance, some CVC sequence of Thai text (C is consonant, V is upper vowel) is drawn so that V is placed over the middle of two Cs. If this CVC sequence is already drawn and only the last C is drawn again (for instance by updating cursor position), the right half of V is erased if this member is zero. By setting this member to nonzero, even with such a drawing, we can keep this CVC sequence correctly displayed. </p>

</div>
</div>
<a class="anchor" id="a5e496fa6dcad730d7d04048b87c0d01e"></a><!-- doxytag: member="MDrawControl::disable_caching" ref="a5e496fa6dcad730d7d04048b87c0d01e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMDrawControl.html#a5e496fa6dcad730d7d04048b87c0d01e">MDrawControl::disable_caching</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If nonzero, don't cache the result of any drawing information of an M-text. </p>

</div>
</div>
<a class="anchor" id="a3485775bf4708899bbad2626e6c594ce"></a><!-- doxytag: member="MDrawControl::clip_region" ref="a3485775bf4708899bbad2626e6c594ce" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nDraw.html#ga9818c0695d9162a9637fa4e98a1d477d">MDrawRegion</a> <a class="el" href="structMDrawControl.html#a3485775bf4708899bbad2626e6c594ce">MDrawControl::clip_region</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>If non-NULL, limit the drawing effect to the specified region. </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
